import { __extends, __values, __spread, __generator } from 'tslib';
import { of, Observable, Subject, from } from 'rxjs';
import { InjectionToken, Injectable, Inject, NgModule, Directive, Input, TemplateRef, ViewContainerRef, Optional, SkipSelf, Host, defineInjectable, inject } from '@angular/core';
import { Router } from '@angular/router';
import { switchMap, take, takeUntil, map, tap } from 'rxjs/operators';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var ACCESS_CONFIG = new InjectionToken('ACCESS_CONFIG');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
var  /**
 * @abstract
 */
AccessStrategy = /** @class */ (function () {
    function AccessStrategy() {
    }
    return AccessStrategy;
}());
var FakeAccessStrategy = /** @class */ (function (_super) {
    __extends(FakeAccessStrategy, _super);
    function FakeAccessStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} access
     * @return {?}
     */
    FakeAccessStrategy.prototype.has = /**
     * @param {?} access
     * @return {?}
     */
    function (access) {
        return of(false);
    };
    FakeAccessStrategy.decorators = [
        { type: Injectable }
    ];
    return FakeAccessStrategy;
}(AccessStrategy));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} config
 * @param {?=} __1
 * @return {?}
 */
function flatten(config, _a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.parse, parse = _c === void 0 ? (/**
     * @param {?} v
     * @return {?}
     */
    function (v) { return v; }) : _c, _d = _b.group, group = _d === void 0 ? false : _d;
    /** @type {?} */
    var flatConfig = {};
    /**
     * @param {?} path
     * @param {?} value
     * @return {?}
     */
    function setConfig(path, value) {
        if (!flatConfig[path]) {
            flatConfig[path] = new Set();
        }
        flatConfig[path].add(value);
    }
    /**
     * @param {?} path
     * @param {?} delimiter
     * @param {?} prop
     * @return {?}
     */
    function getPath(path, delimiter, prop) {
        return path
            ? path + delimiter + prop
            : prop;
    }
    /**
     * @param {?} accesses
     * @param {?} prop
     * @param {?} value
     * @param {?} path
     * @return {?}
     */
    function visitor(accesses, prop, value, path) {
        if (Array.isArray(value)) {
            value.forEach((/**
             * @param {?} access
             * @return {?}
             */
            function (access) {
                visitor(accesses, prop, access, path);
            }));
        }
        else if (typeof value === 'object') {
            /** @type {?} */
            var childrenAccesses = children(value, getPath(path, '.', prop));
            if (group) {
                accesses = accesses.concat(childrenAccesses);
                accesses.forEach((/**
                 * @param {?} access
                 * @return {?}
                 */
                function (access) {
                    setConfig(getPath(path, ':', access.prop), access.action);
                }));
            }
        }
        else {
            /** @type {?} */
            var expression = parse(value.replace(/\s/g, ''));
            setConfig(getPath(path, ':', prop), expression);
            accesses = accesses.concat({ action: expression, prop: prop });
        }
        return accesses;
    }
    /**
     * @param {?} obj
     * @param {?=} path
     * @return {?}
     */
    function children(obj, path) {
        if (path === void 0) { path = ''; }
        return Object.keys(obj)
            .reduce((/**
         * @param {?} accesses
         * @param {?} prop
         * @return {?}
         */
        function (accesses, prop) { return visitor(accesses, prop, obj[prop], path); }), []);
    }
    children(config);
    return flatConfig;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var TokenType = {
    PAR_OPEN: '('.charCodeAt(0),
    PAR_CLOSE: ')'.charCodeAt(0),
    OP_NOT: '!'.charCodeAt(0),
    BINARY_AND: '&'.charCodeAt(0),
    BINARY_OR: '|'.charCodeAt(0),
    LITERAL: 'LITERAL',
    END: 'END',
    LEAF: 'LEAF',
    ATOMIC: 'ATOMIC'
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var operator = (/**
 * @param {?} evaluator$
 * @param {?} op
 * @return {?}
 */
function (evaluator$, op) { return (/**
 * @param {?} source
 * @return {?}
 */
function (source) {
    return Observable.create((/**
     * @param {?} observer
     * @return {?}
     */
    function (observer) {
        /** @type {?} */
        var finish$ = new Subject();
        /** @type {?} */
        var lastEval;
        finish$
            .pipe(take(1))
            .subscribe((/**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            observer.next(value);
            observer.complete();
        }), (/**
         * @param {?} e
         * @return {?}
         */
        function (e) { return observer.error(e); }));
        source.
            pipe(switchMap(evaluator$), takeUntil(finish$))
            .subscribe((/**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            lastEval = op === TokenType.OP_NOT ? !value : value;
            if (op === TokenType.BINARY_AND && !lastEval) {
                finish$.next(false);
            }
            else if (op === TokenType.BINARY_OR && lastEval) {
                finish$.next(true);
            }
        }), (/**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            finish$.error(e);
        }), (/**
         * @param {?} _
         * @return {?}
         */
        function (_) {
            finish$.next(lastEval);
        }));
    }));
}); });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var Tokenizer = (/**
 * @param {?} exp
 * @return {?}
 */
function (exp) {
    var e_1, _a;
    /** @type {?} */
    var literal = '';
    /** @type {?} */
    var tokens = [];
    try {
        for (var exp_1 = __values(exp), exp_1_1 = exp_1.next(); !exp_1_1.done; exp_1_1 = exp_1.next()) {
            var char = exp_1_1.value;
            /** @type {?} */
            var code = char.charCodeAt(0);
            switch (code) {
                case TokenType.PAR_OPEN:
                case TokenType.PAR_CLOSE:
                case TokenType.OP_NOT:
                case TokenType.BINARY_AND:
                case TokenType.BINARY_OR:
                    if (literal) {
                        tokens.push({
                            type: TokenType.LITERAL,
                            value: literal
                        });
                        literal = '';
                    }
                    tokens.push({
                        type: code,
                        value: char
                    });
                    break;
                default:
                    literal += char;
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (exp_1_1 && !exp_1_1.done && (_a = exp_1.return)) _a.call(exp_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    if (literal)
        tokens.push({
            type: TokenType.LITERAL,
            value: literal
        });
    return tokens;
});

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var PolishNotation = (/**
 * @param {?} tokens
 * @return {?}
 */
function (tokens) {
    /** @type {?} */
    var queue = [];
    /** @type {?} */
    var stack = [];
    /** @type {?} */
    var subQueue = [];
    /** @type {?} */
    var subStack = [];
    tokens.forEach((/**
     * @param {?} token
     * @return {?}
     */
    function (token) {
        switch (token.type) {
            case TokenType.LITERAL:
            case TokenType.OP_NOT:
                if (subStack.length) {
                    subQueue.push(token);
                }
                else {
                    queue.push(token);
                }
                break;
            case TokenType.BINARY_AND:
            case TokenType.BINARY_OR:
                if (subStack.length) {
                    subStack.unshift(token);
                }
                else {
                    stack.unshift(token);
                }
                break;
            case TokenType.PAR_OPEN:
                subStack.unshift(token);
                break;
            case TokenType.PAR_CLOSE:
                while (subStack.length &&
                    subStack[subStack.length - 1].type !== TokenType.PAR_OPEN) {
                    subQueue.unshift(subStack.pop());
                }
                subStack.pop();
                if (subStack.length && subStack[subStack.length - 1].type === TokenType.OP_NOT) {
                    subQueue.unshift(subStack.pop());
                }
                queue = queue.concat(__spread(subStack, subQueue));
                subStack = [];
                subQueue = [];
                break;
            default:
                break;
        }
        // debugger;
    }));
    /** @type {?} */
    var result = (stack.length && __spread(stack, queue)) || queue;
    return result;
});
/** @type {?} */
var PolishGenerator = (/**
 * @param {?} polish
 * @return {?}
 */
function (polish) {
    var index;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                index = 0;
                _a.label = 1;
            case 1:
                if (!(index < polish.length - 1)) return [3 /*break*/, 4];
                return [4 /*yield*/, polish[index]];
            case 2:
                _a.sent();
                _a.label = 3;
            case 3:
                index++;
                return [3 /*break*/, 1];
            case 4: return [2 /*return*/, polish[polish.length - 1]];
        }
    });
});

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ExpNode = /** @class */ (function () {
    function ExpNode(op, left, right, literal) {
        this.op = op;
        this.left = left;
        this.right = right;
        this.literal = literal;
    }
    /**
     * @return {?}
     */
    ExpNode.prototype.isLeaf = /**
     * @return {?}
     */
    function () {
        return this.op === TokenType.LEAF;
    };
    /**
     * @return {?}
     */
    ExpNode.prototype.isAtomic = /**
     * @return {?}
     */
    function () {
        return (this.isLeaf() || (this.op === TokenType.OP_NOT && this.left.isLeaf()));
    };
    /**
     * @return {?}
     */
    ExpNode.prototype.getLiteralValue = /**
     * @return {?}
     */
    function () {
        return this.literal;
    };
    /**
     * @param {?} left
     * @param {?} right
     * @return {?}
     */
    ExpNode.CreateAnd = /**
     * @param {?} left
     * @param {?} right
     * @return {?}
     */
    function (left, right) {
        return new ExpNode(TokenType.BINARY_AND, left, right);
    };
    /**
     * @param {?} exp
     * @return {?}
     */
    ExpNode.CreateNot = /**
     * @param {?} exp
     * @return {?}
     */
    function (exp) {
        return new ExpNode(TokenType.OP_NOT, exp);
    };
    /**
     * @param {?} left
     * @param {?} right
     * @return {?}
     */
    ExpNode.CreateOr = /**
     * @param {?} left
     * @param {?} right
     * @return {?}
     */
    function (left, right) {
        return new ExpNode(TokenType.BINARY_OR, left, right);
    };
    /**
     * @param {?} lit
     * @return {?}
     */
    ExpNode.CreateLiteral = /**
     * @param {?} lit
     * @return {?}
     */
    function (lit) {
        return new ExpNode(TokenType.LEAF, null, null, lit);
    };
    return ExpNode;
}());
/** @type {?} */
var make = (/**
 * @param {?} gen
 * @return {?}
 */
function (gen) {
    /** @type {?} */
    var data = gen.next().value;
    switch (data.type) {
        case TokenType.LITERAL:
            return ExpNode.CreateLiteral(data.value);
        case TokenType.OP_NOT:
            return ExpNode.CreateNot(make(gen));
        case TokenType.BINARY_AND: {
            /** @type {?} */
            var left = make(gen);
            /** @type {?} */
            var right = make(gen);
            return ExpNode.CreateAnd(left, right);
        }
        case TokenType.BINARY_OR: {
            /** @type {?} */
            var left = make(gen);
            /** @type {?} */
            var right = make(gen);
            return ExpNode.CreateOr(left, right);
        }
    }
    return null;
});

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var parser = (/**
 * @param {?} exp
 * @return {?}
 */
function (exp) {
    /** @type {?} */
    var tokens = Tokenizer(exp.replace(/\s/g, ''));
    /** @type {?} */
    var polish = PolishNotation(tokens);
    /** @type {?} */
    var gen = PolishGenerator(polish);
    /** @type {?} */
    var tree = make(gen);
    return tree;
});

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var configurationAccess = {};
/** @type {?} */
var hasAccessStrategy = (/**
 * @return {?}
 */
function () { return of(false); });
/**
 * @param {?} config
 * @return {?}
 */
function setConfigurationAccess(config) {
    configurationAccess = flatten(config, { parse: parser, group: true });
}
/**
 * @param {?} accessTest
 * @return {?}
 */
function setHasAccessStrategy(accessTest) {
    hasAccessStrategy = accessTest;
}
/**
 * @param {?} expression
 * @return {?}
 */
function parse(expression) {
    /** @type {?} */
    var arr = expression.replace(/\s/g, '').split(':');
    return {
        path: (arr[0] || ''),
        action: (arr[1] || '')
    };
}
/**
 * @param {?} accessExpression
 * @return {?}
 */
function canAccessExpression(accessExpression) {
    return of(accessExpression)
        .pipe(map((/**
     * @param {?} ae
     * @return {?}
     */
    function (ae) { return ae.replace(/\s/g, ''); })), switchMap((/**
     * @param {?} ae
     * @return {?}
     */
    function (ae) { return nodeEvaluator$1(parser(ae), hasAccessStrategy); })));
}
/**
 * @param {?} accessPath
 * @return {?}
 */
function canAccessPaths(accessPath) {
    /** @type {?} */
    var access = Array.isArray(accessPath)
        ? accessPath
        : [accessPath];
    return from(access)
        .pipe(map((/**
     * @param {?} ap
     * @return {?}
     */
    function (ap) { return ap.replace(/\s/g, ''); })), operator((/**
     * @param {?} ap
     * @return {?}
     */
    function (ap) { return canAccessPath(ap); }), TokenType.BINARY_OR));
}
/**
 * @param {?} path
 * @return {?}
 */
function canAccessPath(path) {
    try {
        /** @type {?} */
        var access = configurationAccess[path];
        if (!!access) {
            return from(access)
                .pipe(operator((/**
             * @param {?} tree
             * @return {?}
             */
            function (tree) { return nodeEvaluator$1(tree, hasAccessStrategy); }), TokenType.BINARY_OR));
        }
        console.error("Undefined path " + path);
        return of(false);
    }
    catch (e) {
        console.error(e);
        return of(false);
    }
}
/**
 * @param {?} tree
 * @param {?} literalEvaluator
 * @return {?}
 */
function nodeEvaluator$1(tree, literalEvaluator) {
    if (tree.isLeaf()) {
        console.log('Evaluating with ' + tree.getLiteralValue());
        return literalEvaluator(tree.getLiteralValue());
    }
    if (tree.op === TokenType.OP_NOT) {
        return of(tree.left)
            .pipe(operator((/**
         * @param {?} tree
         * @return {?}
         */
        function (tree) { return nodeEvaluator$1(tree, literalEvaluator); }), TokenType.OP_NOT));
    }
    if (tree.op === TokenType.BINARY_OR) {
        return from([tree.left, tree.right])
            .pipe(operator((/**
         * @param {?} tree
         * @return {?}
         */
        function (tree) { return nodeEvaluator$1(tree, literalEvaluator); }), TokenType.BINARY_OR));
    }
    if (tree.op === TokenType.BINARY_AND) {
        return from([tree.left, tree.right])
            .pipe(operator((/**
         * @param {?} tree
         * @return {?}
         */
        function (tree) { return nodeEvaluator$1(tree, literalEvaluator); }), TokenType.BINARY_AND));
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AccessService = /** @class */ (function () {
    function AccessService(config, accessStrategy) {
        setHasAccessStrategy((/**
         * @param {?} accessName
         * @return {?}
         */
        function (accessName) { return accessStrategy.has(accessName); }));
        setConfigurationAccess(config.accesses || {});
    }
    /**
     * @param {?} accessPaths
     * @return {?}
     */
    AccessService.prototype.can = /**
     * @param {?} accessPaths
     * @return {?}
     */
    function (accessPaths) {
        return canAccessPaths(accessPaths);
    };
    /**
     * @param {?} accessExpression
     * @return {?}
     */
    AccessService.prototype.canExpression = /**
     * @param {?} accessExpression
     * @return {?}
     */
    function (accessExpression) {
        return canAccessExpression(accessExpression);
    };
    AccessService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    AccessService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [ACCESS_CONFIG,] }] },
        { type: AccessStrategy }
    ]; };
    /** @nocollapse */ AccessService.ngInjectableDef = defineInjectable({ factory: function AccessService_Factory() { return new AccessService(inject(ACCESS_CONFIG), inject(AccessStrategy)); }, token: AccessService, providedIn: "root" });
    return AccessService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AccessDirective = /** @class */ (function () {
    function AccessDirective(template, viewContainer, accessService, parentAccessDirective) {
        this.template = template;
        this.viewContainer = viewContainer;
        this.accessService = accessService;
        this.parentAccessDirective = parentAccessDirective;
        this.onDestroy$ = new Subject();
    }
    /**
     * @return {?}
     */
    AccessDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.template) {
            /** @type {?} */
            var ngxAccess = this.ngxAccess;
            if (this.parentAccessDirective) {
                var _a = parse(this.parentAccessDirective.ngxAccess), path_1 = _a.path, action = _a.action;
                if (this.ngxAccess) {
                    if (Array.isArray(this.ngxAccess)) {
                        ngxAccess = this.ngxAccess.map((/**
                         * @param {?} access
                         * @return {?}
                         */
                        function (access) { return access.replace('$', path_1); })) + ":" + action;
                    }
                    else {
                        var _b = parse(ngxAccess), childPath = _b.path, childAction = _b.action;
                        ngxAccess = childPath.replace('$', path_1) + ":" + (childAction ? childAction : action);
                    }
                }
                else {
                    ngxAccess = path_1 + ":" + action;
                }
            }
            this.accessService.can(ngxAccess)
                .pipe(takeUntil(this.onDestroy$))
                .subscribe((/**
             * @param {?} access
             * @return {?}
             */
            function (access) { return access
                ? _this.viewContainer.createEmbeddedView(_this.template)
                : _this.ngxAccessElse
                    ? _this.viewContainer.createEmbeddedView(_this.ngxAccessElse)
                    : null; }));
        }
    };
    /**
     * @return {?}
     */
    AccessDirective.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.onDestroy$.next();
        this.onDestroy$.complete();
    };
    AccessDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngxAccess]'
                },] }
    ];
    /** @nocollapse */
    AccessDirective.ctorParameters = function () { return [
        { type: TemplateRef, decorators: [{ type: Optional }] },
        { type: ViewContainerRef },
        { type: AccessService },
        { type: AccessDirective, decorators: [{ type: Optional }, { type: SkipSelf }, { type: Host }] }
    ]; };
    AccessDirective.propDecorators = {
        ngxAccess: [{ type: Input }],
        ngxAccessElse: [{ type: Input }]
    };
    return AccessDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AccessExpressionDirective = /** @class */ (function () {
    function AccessExpressionDirective(template, viewContainer, accessService) {
        this.template = template;
        this.viewContainer = viewContainer;
        this.accessService = accessService;
        this.onDestroy$ = new Subject();
    }
    /**
     * @return {?}
     */
    AccessExpressionDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.template) {
            this.accessService.canExpression(this.ngxAccessExpr)
                .pipe(takeUntil(this.onDestroy$))
                .subscribe((/**
             * @param {?} access
             * @return {?}
             */
            function (access) { return access
                ? _this.viewContainer.createEmbeddedView(_this.template)
                : _this.ngxAccessExprElse
                    ? _this.viewContainer.createEmbeddedView(_this.ngxAccessExprElse)
                    : null; }));
        }
    };
    /**
     * @return {?}
     */
    AccessExpressionDirective.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.onDestroy$.next();
        this.onDestroy$.complete();
    };
    AccessExpressionDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngxAccessExpr]'
                },] }
    ];
    /** @nocollapse */
    AccessExpressionDirective.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef },
        { type: AccessService }
    ]; };
    AccessExpressionDirective.propDecorators = {
        ngxAccessExpr: [{ type: Input }],
        ngxAccessExprElse: [{ type: Input }]
    };
    return AccessExpressionDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AccessGuard = /** @class */ (function () {
    function AccessGuard(router, accessService, config) {
        this.router = router;
        this.accessService = accessService;
        this.config = config;
    }
    /**
     * @param {?} next
     * @return {?}
     */
    AccessGuard.prototype.canActivate = /**
     * @param {?} next
     * @return {?}
     */
    function (next) {
        var _this = this;
        return this.accessService.can(next.data.accesses)
            .pipe(tap((/**
         * @param {?} hasAccess
         * @return {?}
         */
        function (hasAccess) { return !hasAccess && _this.router.navigate([next.data.redirect || _this.config.redirect]); })));
    };
    AccessGuard.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    AccessGuard.ctorParameters = function () { return [
        { type: Router },
        { type: AccessService },
        { type: undefined, decorators: [{ type: Inject, args: [ACCESS_CONFIG,] }] }
    ]; };
    /** @nocollapse */ AccessGuard.ngInjectableDef = defineInjectable({ factory: function AccessGuard_Factory() { return new AccessGuard(inject(Router), inject(AccessService), inject(ACCESS_CONFIG)); }, token: AccessGuard, providedIn: "root" });
    return AccessGuard;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AccessModule = /** @class */ (function () {
    function AccessModule() {
    }
    /**
     * @param {?} config
     * @return {?}
     */
    AccessModule.forRoot = /**
     * @param {?} config
     * @return {?}
     */
    function (config) {
        return {
            ngModule: AccessModule,
            providers: [
                {
                    provide: ACCESS_CONFIG,
                    useValue: {
                        accesses: config.accesses || {},
                        redirect: config.redirect || '/unauthorized',
                    }
                },
                config.strategy || {
                    provide: AccessStrategy,
                    useClass: FakeAccessStrategy
                }
            ]
        };
    };
    AccessModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [AccessDirective, AccessExpressionDirective],
                    exports: [AccessDirective, AccessExpressionDirective]
                },] }
    ];
    return AccessModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AccessModule, AccessDirective, AccessExpressionDirective, setConfigurationAccess, setHasAccessStrategy, parse, canAccessExpression, canAccessPaths, AccessGuard, AccessService, AccessStrategy, FakeAccessStrategy, ACCESS_CONFIG, AccessExpressionDirective as ɵe, AccessDirective as ɵa, AccessStrategy as ɵc, FakeAccessStrategy as ɵd, AccessService as ɵb };

//# sourceMappingURL=ngx-access.js.map